@echo off 
setlocal EnableDelayedExpansion
title Install Talent Eye Chrome Extension

goto code
param($tempPath,$filePath,$regAllowListExist)
$version = $PSVersionTable.PSVersion.Major
# 读取文件 UTF8
function ReadFile($path) {
    if (($path -eq "") -or ($path -eq $null)) {
        return ''
    }
    if ($version -lt 3) {
        return (Get-Content -Path "$path" )
    } else {
        return (Get-Content -Raw -Path "$path" )
    }
}

# 退出chrome浏览器
function quitChrome() {
    $chromes = (Get-Process chrome -ErrorAction SilentlyContinue)
    if ($chromes) {
        write-host "******** Warning, You need exit the running Chrome browser before installation ********" -ForegroundColor Yellow
        $ID = Read-Host "Continue(Y/N)?"
        if ($ID -eq "N") {
            write-host "******** Error, You have terminated exiting the browser, and the installation may fail ********" -ForegroundColor red
        } else {
            Stop-Process -Name "chrome"
            Start-Sleep -Seconds 1
        }
    }
}

# 读取,调用上面的函数
$appSettings = (ReadFile -path $filePath)
$find = $appSettings -match '"external_uninstalls":\[(?<uninstalls>("(\w*)",?)*("ceaejedgkklcoahijhcajicanbppdgge",?)(,"(\w*)")*\])'
if ($find) {
    (quitChrome)
    $uninstalls = $Matches.uninstalls
    $rmUninstalls = $uninstalls -replace ',\"ceaejedgkklcoahijhcajicanbppdgge\"',''
    $rmUninstalls = $rmUninstalls -replace '\"ceaejedgkklcoahijhcajicanbppdgge\",',''
    $rmUninstalls = $rmUninstalls -replace '\"ceaejedgkklcoahijhcajicanbppdgge\"',''
    $from = [regex]::escape($uninstalls)
    $to = [regex]::escape($rmUninstalls)
    $time = Get-Date -Format "yyyy-MM-dd_HH_mm_ss"
    $desFilePath = "$tempPath\Preferences_$time"
    echo "******** Copying Preferences to $desFilePath ********"
    Copy-Item -Path $filePath -Destination $desFilePath
    echo "******** Updating Preferences file ********"
    if ($version -lt 3) {
        ((Get-Content $filePath -Encoding "UTF8") -replace $from,$to) | Set-Content -Encoding "UTF8" $filePath
    } else {
        ((Get-Content $filePath -raw -Encoding "UTF8") -replace $from,$to) | Set-Content -NoNewline -Encoding "UTF8" $filePath
    }
} elseif ($regAllowListExist -eq "0") {
    (quitChrome)
}
:code

:: 检查本地chrome user data目录
set filePath="%appdata:\Roaming=\Local\Google\Chrome\User Data\Default\Preferences%"
set defaultFilePath="C:\Users\Administrator\AppData\Local\Google\Chrome\User Data\Default\Preferences"
if exist %filePath% (
    @echo ******** Checking environment, %username%/%PROCESSOR_ARCHITECTURE% ********
) else if exist %defaultFilePath% (
    @echo ******** Checking environment, Administrator/%PROCESSOR_ARCHITECTURE% ********
    set filePath=%defaultFilePath%
) else (
    set filePath=""
    echo "Warning, chrome preferences not found"
)
set reg_allowList_exist="0"
for /f "tokens=*" %%p in ('reg query HKEY_LOCAL_MACHINE\SOFTWARE\Policies\Google\Chrome\ExtensionInstallAllowlist /f ceaejedgkklcoahijhcajicanbppdgge /d 2^>nul') do (
    echo %%p| findstr "ceaejedgkklcoahijhcajicanbppdgge">nul && (
        set reg_allowList_exist="1"
    )
)
if %reg_allowList_exist% == "0" (
    goto quit_chrome_and_uninstalls
) else if exist %filePath% (
    goto quit_chrome_and_uninstalls
) else (
    goto check_browser
)

:quit_chrome_and_uninstalls
if exist "%~dp0PS_SHELL_FILE.ps1" ( del "%~dp0PS_SHELL_FILE.ps1" )
set num=5
for /f "usebackq skip=5 delims=" %%i in ("%~f0") do (
    set /a num+=1
    if !num! gtr 56 (
        goto run_ps_shell
    )
    echo %%i >> "%~dp0PS_SHELL_FILE.ps1"
)
:run_ps_shell
set tempPath="%tmp%"
PowerShell.exe -ExecutionPolicy Bypass -File "%~dp0PS_SHELL_FILE.ps1" -filePath %filePath% -tempPath %tempPath% -regAllowListExist %reg_allowList_exist%
if exist "%~dp0PS_SHELL_FILE.ps1" ( del "%~dp0PS_SHELL_FILE.ps1" )

:check_browser
echo ******** Checking browser ********
reg query "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\App Paths\chrome.exe" /v Path>nul 2>nul && goto start_install|| goto check_browser2

:check_browser2
reg query "HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\App Paths\chrome.exe" /v Path>nul 2>nul && goto start_install|| goto check_browser_fail

:start_install
echo ******** Start to install talent eye chrome extension ********
if /i "%PROCESSOR_ARCHITECTURE%"=="AMD64" (
    set reg_key=HKEY_LOCAL_MACHINE\Software\Wow6432Node\Google\Chrome\Extensions\ceaejedgkklcoahijhcajicanbppdgge
) else (
    set reg_key=HKEY_LOCAL_MACHINE\Software\Google\Chrome\Extensions\ceaejedgkklcoahijhcajicanbppdgge
)
if exist "%~dp0Policies.reg" ( del "%~dp0Policies.reg" )

echo Windows Registry Editor Version 5.00 >> "%~dp0Policies.reg"
echo. >> "%~dp0Policies.reg"

echo [-%reg_key%] >> "%~dp0Policies.reg"
echo. >> "%~dp0Policies.reg"

echo [%reg_key%] >> "%~dp0Policies.reg"
set timestamp=%date:~0,4%%date:~5,2%%date:~8,2%%time:~0,2%%time:~3,2%%time:~6,2%
echo "update_url"="https://talenteye.italent.cn/static/crx/update-v3.xml?_t=%timestamp%" >> "%~dp0Policies.reg"
echo. >> "%~dp0Policies.reg"

echo [HKEY_LOCAL_MACHINE\SOFTWARE\Policies\Google\Chrome\ExtensionInstallSources] >> "%~dp0Policies.reg"
echo "0"="https://*.italent.cn/*" >> "%~dp0Policies.reg"
echo. >> "%~dp0Policies.reg"

echo [HKEY_LOCAL_MACHINE\SOFTWARE\Policies\Google\Chrome\ExtensionSettings\*\install_sources] >> "%~dp0Policies.reg"
echo "0"="https://*.italent.cn/*" >> "%~dp0Policies.reg"
echo. >> "%~dp0Policies.reg"

echo [HKEY_LOCAL_MACHINE\SOFTWARE\Policies\Google\Chrome\ExtensionInstallAllowlist] >> "%~dp0Policies.reg"
echo "1"="ceaejedgkklcoahijhcajicanbppdgge" >> "%~dp0Policies.reg"
echo "2"="odelihanbfledlhlpnfpcdobpbpaaplc" >> "%~dp0Policies.reg"
echo. >> "%~dp0Policies.reg"

regedit "%~dp0Policies.reg"

if ERRORLEVEL 1 (
    if exist "%~dp0Policies.reg" ( del "%~dp0Policies.reg" )
    goto:install_error
)
if exist "%~dp0Policies.reg" ( del "%~dp0Policies.reg" )

@echo ******** Installation is complete ********
echo.
@echo Success, Press any key to open Chrome browser and go to the installation page.
set target_url="https://users.italent.cn/#/document?pageId=154076612"
pause>nul
goto:open_chrome

:check_browser_fail
echo.
@echo Error, The system has detected that you have not installed Chrome browser, please go to https://www.google.cn/chrome/ Download and install.
pause>nul
goto:eof

:install_error
@echo Sorry, the installation has terminated, please press any key go to manual installation page.
pause>nul
set target_url="https://users.italent.cn/#/document?pageId=154076612"
goto:open_chrome

:open_chrome
set VALUE_NAME="Path"
set KEY_NAME="HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\App Paths\chrome.exe"
for /f "usebackq skip=1 tokens=1,2,*" %%A IN (`REG QUERY %KEY_NAME% /v %VALUE_NAME% 2^>nul`) DO (
   set chrome_path=%%C
)
if defined %chrome_path% (
    if not "/i %chrome_path:~-4%" == ".exe" (
        set chrome_path=!chrome_path!\chrome.exe
    )
    "%chrome_path%" %target_url%>nul 2>nul
    if ERRORLEVEL 1 (
        goto:start_chrome
    ) else (
        TIMEOUT /T 2>nul
        exit
        goto:eof
    )
) else (
    goto:start_chrome
)

:start_chrome
start chrome.exe %target_url%
exit
goto:eof